# coding: utf-8
class String

  EN_RU = {}

  RU_EN = {
    'А' => 'A', 'а' => 'a', 'Б' => 'B', 'б' => 'b', 'В' => 'V', 'в' => 'v', 'Г' => 'G', 'г' => 'g', 'Д' => 'D', 'д' => 'd',
    'Е' => 'E', 'е' => 'e', 'Ё' => 'Jo', 'ё' => 'jo', 'Ж' => 'Zh', 'ж' => 'zh', 'З' => 'Z', 'з' => 'z', 'И' => 'I',
    'и' => 'i', 'Й' => 'J', 'й' => 'j', 'К' => 'K', 'к' => 'k', 'Л' => 'L', 'л' => 'l', 'М' => 'M', 'м' => 'm', 'Н' => 'N',
    'н' => 'n', 'О' => 'O', 'о' => 'o', 'П' => 'P', 'п' => 'p', 'Р' => 'R', 'р' => 'r', 'С' => 'S', 'с' => 's', 'Т' => 'T',
    'т' => 't', 'У' => 'U', 'у' => 'u', 'Ф' => 'F', 'ф' => 'f', 'Х' => 'H', 'х' => 'h', 'Ц' => 'C', 'ц' => 'c', 'Ч' => 'Ch',
    'ч' => 'ch', 'Щ' => 'Shh', 'щ' => 'shh', 'Ш' => 'Sh', 'ш' => 'sh', 'Ы' => 'Y', 'ы' => 'y', 'Ь' => "''", 'ь' => "'",
    'Ъ' => '##', 'ъ' => '#', 'Э' => 'Je', 'э' => 'je', 'Ю' => 'Ju', 'ю' => 'ju', 'Я' => 'Ja', 'я' => 'ja'
  }

  UA_EN = {
    'А' => 'A', 'а' => 'a', 'Б' => 'B', 'б' => 'b', 'В' => 'V', 'в' => 'v', 'Г' => 'G', 'г' => 'g', 'Ґ' => "G'", 'ґ' => "g'",
    'Д' => 'D', 'д' => 'd', 'Е' => 'E', 'е' => 'e', 'Є' => 'Je', 'є' => 'je', 'Ж' => 'Zh', 'ж' => 'zh', 'З' => 'Z', 'з' => 'z',
    'И' => 'Y', 'и' => 'y', 'І' => 'I', 'і' => 'i', 'Ї' => "I'", 'ї' => "i'", 'Й' => 'J', 'й' => 'j', 'К' => 'K', 'к' => 'k',
    'Л' => 'L', 'л' => 'l', 'М' => 'M', 'м' => 'm', 'Н' => 'N', 'н' => 'n', 'О' => 'O', 'о' => 'o', 'П' => 'P', 'п' => 'p',
    'Р' => 'R', 'р' => 'r', 'С' => 'S', 'с' => 's', 'Т' => 'T', 'т' => 't', 'У' => 'U', 'у' => 'u', 'Ф' => 'F', 'ф' => 'f',
    'Х' => 'H', 'х' => 'h', 'Ц' => 'C', 'ц' => 'c', 'Ч' => 'Ch', 'ч' => 'ch', 'Щ' => 'Shh', 'щ' => 'shh', 'Ш' => 'Sh', 'ш' => 'sh',
    'Ы' => 'Y', 'ы' => 'y', 'Ь' => "''", 'ь' => "'", 'Э' => 'Je', 'э' => 'je', 'Ю' => 'Ju', 'ю' => 'ju', 'Я' => 'Ja', 'я' => 'ja'
  }

  def translit(options = { from: 'en', to: 'ru' })
    h = EN_RU
    h = if ru_en?(options)
      RU_EN
    elsif ua_en?(options)
      UA_EN
    end

    self.split('').map do |char|
      h[char] ? h[char] : char
    end.join('')
  end

  private

  def ru_en?(options)
    options && options[:from] == 'ru' && options[:to] == 'en'
  end

  def ua_en?(options)
    options && options[:from] == 'ua' && options[:to] == 'en'
  end

end
